from search_index_import_commons.SearchIndexImportMapping import SearchIndexImportMapping
import search_index_import_commons.constants.KimHochschulfaechersystematik as Subject


class LUHStudIpMapping(SearchIndexImportMapping):
    def __init__(self):
        self.add_mapping("subject", {
            "1. Mathematik und Naturwissenschaften": Subject.N4_MATHEMATICS_NATURAL_SCIENCES,
            "1.1 Mathematik I": Subject.N37_MATHEMATICS,
            "1.3 Mathematik III / IV": Subject.N37_MATHEMATICS,
            "2. Elektrotechnik und Informationstechnik": Subject.N64_ELECTRICAL_ENGINEERING_AND_INFORMATION_ENGINEERING,
            "2.1 Elektrotechnik": Subject.N64_ELECTRICAL_ENGINEERING_AND_INFORMATION_ENGINEERING,
            "3.1 Werkstoffkunde I": Subject.N177_MATERIALS_TECHNOLOGY,
            "Allgemeiner Maschinenbau": Subject.N63_MECHANICAL_ENGINEERING__PROCESS_ENGINEERING,
            "Anschließender Master Mechatronik und Robotik": Subject.N380_MECHATRONICS,
            "Bachelor Maschinenbau (Sommersemesterzulassung)": Subject.N63_MECHANICAL_ENGINEERING__PROCESS_ENGINEERING,
            "Bachelor Maschinenbau (Wintersemesterzulassung)": Subject.N63_MECHANICAL_ENGINEERING__PROCESS_ENGINEERING,
            "Bachelor Technical Education - Metalltechnik": Subject.N108_METALS_TECHNOLOGY,
            "Bauingenieurwesen, M. Sc. (PO´19)": Subject.N68_CIVIL_ENGINEERING,
            "Biomedizintechnik": Subject.N300_BIOMEDICINE,
            "Bioverfahrenstechnik": Subject.N282_BIOTECHNOLOGY,
            "Data Science": Subject.N71_COMPUTER_SCIENCE,
            "Didaktik der Elektrotechnik und Informatik": Subject.N33_EDUCATIONAL_SCIENCES,
            "Didaktik der Technik": Subject.N33_EDUCATIONAL_SCIENCES,
            "Elektroprozesstechnik": Subject.N64_ELECTRICAL_ENGINEERING_AND_INFORMATION_ENGINEERING,
            "Elektrotechnik und Informationstechnik": Subject.N64_ELECTRICAL_ENGINEERING_AND_INFORMATION_ENGINEERING,
            "Energie- und Verfahrenstechnik (EuV)": Subject.N211_ENERGY_PROCESS_ENGINEERING,
            "Energie- und Verfahrenstechnik": Subject.N211_ENERGY_PROCESS_ENGINEERING,
            "Fachdidaktik": Subject.N33_EDUCATIONAL_SCIENCES,
            "Fahrzeugmechatronik": Subject.N235_AUTOMOTIVE_TECHNOLOGY,
            "Fahrzeugtechnik": Subject.N235_AUTOMOTIVE_TECHNOLOGY,
            "Fakultät für Bauingenieurwesen und Geodäsie": Subject.N8_ENGINEERING_SCIENCES,
            "Fakultät für Elektrotechnik und Informatik": Subject.N8_ENGINEERING_SCIENCES,
            "Fakultät für Elektrotechnik": Subject.N64_ELECTRICAL_ENGINEERING_AND_INFORMATION_ENGINEERING,
            "Fakultät für Mathematik und Physik": Subject.N4_MATHEMATICS_NATURAL_SCIENCES,
            "Fakultät für Maschinenbau": Subject.N63_MECHANICAL_ENGINEERING__PROCESS_ENGINEERING,
            "Fernstudium Bauingenieurwesen, M. Sc. - Vertiefung Konstruktiver Ingenieurbau (PO´19)": Subject.N68_CIVIL_ENGINEERING,
            "Fertigungssysteme": Subject.N202_MANUFACTURING_TECHNOLOGY_PRODUCTION_ENGINEERING,
            "Fertigungsverfahren": Subject.N202_MANUFACTURING_TECHNOLOGY_PRODUCTION_ENGINEERING,
            "Geodäsie und Geoinformatik  gemeinsame Veranstaltungen": Subject.N171_SURVEYING_GEODESY,
            "Geodäsie und Geoinformatik gemeinsame Veranstaltungen": Subject.N171_SURVEYING_GEODESY,
            "Geodäsie und Geoinformatik": Subject.N171_SURVEYING_GEODESY,
            "Grundlagen der Elektrotechnik und Messtechnik": Subject.N64_ELECTRICAL_ENGINEERING_AND_INFORMATION_ENGINEERING,
            "Grundlagen der Elektrotechnik": Subject.N64_ELECTRICAL_ENGINEERING_AND_INFORMATION_ENGINEERING,
            "Grundlagen der Ingenieurswissenschaft": Subject.N8_ENGINEERING_SCIENCES,
            "Grundlagen der Ingenieurswissenschaften": Subject.N8_ENGINEERING_SCIENCES,
            "Grundlagen der Ingenieurwissenschaften": Subject.N8_ENGINEERING_SCIENCES,
            "Grundlagen der Produktionstechnik": Subject.N202_MANUFACTURING_TECHNOLOGY_PRODUCTION_ENGINEERING,
            "Grundlagen und Strukturen der beruflichen Fachrichtung Metalltechnik": Subject.N108_METALS_TECHNOLOGY,
            "Grundlagenfeld A: Physik": Subject.N39_PHYSICS_ASTRONOMY,
            "Grundlagenfeld B: Maschinenbau": Subject.N63_MECHANICAL_ENGINEERING__PROCESS_ENGINEERING,
            "Informationsverarbeitung": Subject.N71_COMPUTER_SCIENCE,
            "Ingenieurgeodäsie und geodätische Auswertemethoden": Subject.N171_SURVEYING_GEODESY,
            "Ingenieurwissenschaften": Subject.N8_ENGINEERING_SCIENCES,
            "KB 10: Konstruktiver Ingenieurbau": Subject.N017_CIVIL_ENGINEERING_STRUCTURAL_ENGINEERING,
            "KB 14: Verkehrswesen": Subject.N268_TRANSPORTATION_SYSTEMS,
            "KB 15: Numerische Methoden": Subject.N37_MATHEMATICS,
            "KB 1: Fundamentals of Mathematical and Physical Science": Subject.N4_MATHEMATICS_NATURAL_SCIENCES,
            "KB 1: Mathematik": Subject.N37_MATHEMATICS,
            "KB 1: Mathematisch-naturwissenschaftliche Grundlagen": Subject.N37_MATHEMATICS,
            "KB 2: Baumechanik und Baustatik": Subject.N68_CIVIL_ENGINEERING,
            "KB 3: Naturwissenschaftliche Grundlagen": Subject.N4_MATHEMATICS_NATURAL_SCIENCES,
            "KB 4: Ingenieur- und Umweltinformatik": Subject.N71_COMPUTER_SCIENCE,
            "KB 6: Geodäsie": Subject.N171_SURVEYING_GEODESY,
            "Kartographie und Geoinformatik": Subject.N280_CARTOGRAPHY,
            "Konstruktiver Ingenieurbau": Subject.N68_CIVIL_ENGINEERING,
            "Lehramt an berufsbildenden Schulen f. Fachb. (LBS-Sprint)": Subject.N33_EDUCATIONAL_SCIENCES,
            "Logistik und wirtschaftswissenschaftliche Grundlagen": Subject.N30_BUSINESS_AND_ECONOMICS,
            "Maschinenbau": Subject.N63_MECHANICAL_ENGINEERING__PROCESS_ENGINEERING,
            "Master Biomedizintechnik": Subject.N300_BIOMEDICINE,
            "Master International Mechatronics": Subject.N380_MECHATRONICS,
            "Master LbS Metalltechnik": Subject.N108_METALS_TECHNOLOGY,
            "Master Lehramt für Berufsbildenden Schulen": Subject.N33_EDUCATIONAL_SCIENCES,
            "Master Maschinenbau": Subject.N63_MECHANICAL_ENGINEERING__PROCESS_ENGINEERING,
            "Master Mechatronik und Robotik": Subject.N380_MECHATRONICS,
            "Mathematik Gymnasien und berufsbildende Schulen": Subject.N37_MATHEMATICS,
            "Mathematik Sonderpädagogik": Subject.N37_MATHEMATICS,
            "Mathematik": Subject.N37_MATHEMATICS,
            "Mathematik I": Subject.N37_MATHEMATICS,
            "Mathematik III / IV": Subject.N37_MATHEMATICS,
            "Mathematik und Naturwissenschaften": Subject.N4_MATHEMATICS_NATURAL_SCIENCES,
            "Meteorologie": Subject.N110_METEOROLOGY,
            "Naturwissenschaftliche Fakultät": Subject.N4_MATHEMATICS_NATURAL_SCIENCES,
            "Physik Gymnasien und berufsbildende Schulen": Subject.N39_PHYSICS_ASTRONOMY,
            "Physik": Subject.N39_PHYSICS_ASTRONOMY,
            "Praktische Informatik": Subject.N71_COMPUTER_SCIENCE,
            "Quantum Engineering": Subject.N39_PHYSICS_ASTRONOMY,
            "Systems Engineering": Subject.N71_COMPUTER_SCIENCE,
            "Theoretische Informatik": Subject.N71_COMPUTER_SCIENCE,
            "Umweltmeteorologie": Subject.N110_METEOROLOGY,
            "Vertiefungsbereich Energie- und Verfahrenstechnik": Subject.N211_ENERGY_PROCESS_ENGINEERING,
            "Vertiefungsbereich Produktionstechnik": Subject.N202_MANUFACTURING_TECHNOLOGY_PRODUCTION_ENGINEERING,
            "Vertiefungsbereich: Energie- und Verfahrenstechnik": Subject.N211_ENERGY_PROCESS_ENGINEERING,
            "Vertiefungsbereich: Produktionstechnik": Subject.N202_MANUFACTURING_TECHNOLOGY_PRODUCTION_ENGINEERING,
            "Wahlmodul 1: Biomedizintechnik": Subject.N300_BIOMEDICINE,
            "Wahlmodul 1: Werkstofftechnik": Subject.N177_MATERIALS_TECHNOLOGY,
            "Wahlmodul 2: Robotik und Mechatronik in der Medizintechnik": Subject.N380_MECHATRONICS,
            "Wahlmodul 6: Informatik in der Medizintechnik": Subject.N71_COMPUTER_SCIENCE,
            "Wahlmodul 6: Mechatronik in der Produktionstechnik": Subject.N380_MECHATRONICS,
            "Weiterbildendes Studium Bauingenieurwesen": Subject.N68_CIVIL_ENGINEERING,
            "Werkstofftechnik": Subject.N177_MATERIALS_TECHNOLOGY,
        }, None)

        self.add_mapping("educational_level", {
            "7. Bachelorprojekt": "https://w3id.org/kim/educationalLevel/level_6",
            "Anschließender Master Energietechnik": "https://w3id.org/kim/educationalLevel/level_7",
            "Anschließender Master Mechatronik und Robotik": "https://w3id.org/kim/educationalLevel/level_7",
            "Bachelor 1. Semester": "https://w3id.org/kim/educationalLevel/level_6",
            "Bachelor 2. Semester": "https://w3id.org/kim/educationalLevel/level_6",
            "Bachelor 3. Semester": "https://w3id.org/kim/educationalLevel/level_6",
            "Bachelor 4. Semester": "https://w3id.org/kim/educationalLevel/level_6",
            "Bachelor 5. Semester": "https://w3id.org/kim/educationalLevel/level_6",
            "Bachelor 6. Semester": "https://w3id.org/kim/educationalLevel/level_6",
            "Bachelor Maschinenbau (Sommersemesterzulassung)": "https://w3id.org/kim/educationalLevel/level_6",
            "Bachelor Maschinenbau (Wintersemesterzulassung)": "https://w3id.org/kim/educationalLevel/level_6",
            "Bachelor Nachhaltige Ingenieurwissenschaft (Sommersemesterzulassung)": "https://w3id.org/kim/educationalLevel/level_6",
            "Bachelor Nachhaltige Ingenieurwissenschaft (Wintersemesterzulassung)": "https://w3id.org/kim/educationalLevel/level_6",
            "Bachelor Optische Technologien: Laser und Photonik": "https://w3id.org/kim/educationalLevel/level_6",
            "Bachelor Produktion und Logistik (Sommersemesterzulassung)": "https://w3id.org/kim/educationalLevel/level_6",
            "Bachelor Produktion und Logistik (Wintersemesterzulassung)": "https://w3id.org/kim/educationalLevel/level_6",
            "Bachelor Technical Education - Metalltechnik": "https://w3id.org/kim/educationalLevel/level_6",
            "Bachelor": "https://w3id.org/kim/educationalLevel/level_6",
            "Bachelorarbeit": "https://w3id.org/kim/educationalLevel/level_6",
            "Bachelorprojekt": "https://w3id.org/kim/educationalLevel/level_6",
            "Bau- und Umweltingenieurwesen, B. Sc. (PO´19)": "https://w3id.org/kim/educationalLevel/level_6",
            "Bauingenieurwesen, M. Sc. (PO´19)": "https://w3id.org/kim/educationalLevel/level_7",
            "Computational Methods in Engineering M. Sc. (PO´19)": "https://w3id.org/kim/educationalLevel/level_7",
            "Fernstudium Bauingenieurwesen, M. Sc. - Vertiefung Konstruktiver Ingenieurbau (PO´19)": "https://w3id.org/kim/educationalLevel/level_7",
            "Master Biomedizintechnik": "https://w3id.org/kim/educationalLevel/level_7",
            "Master International Mechatronics": "https://w3id.org/kim/educationalLevel/level_7",
            "Master LbS Metalltechnik": "https://w3id.org/kim/educationalLevel/level_7",
            "Master Lehramt für Berufsbildenden Schulen": "https://w3id.org/kim/educationalLevel/level_7",
            "Master Maschinenbau": "https://w3id.org/kim/educationalLevel/level_7",
            "Master Mechatronik und Robotik": "https://w3id.org/kim/educationalLevel/level_7",
            "Master Optical Technologies": "https://w3id.org/kim/educationalLevel/level_7",
            "Master Optische Technologien": "https://w3id.org/kim/educationalLevel/level_7",
            "Master Pflichtveranstaltungen": "https://w3id.org/kim/educationalLevel/level_7",
            "Master Produktion und Logistik": "https://w3id.org/kim/educationalLevel/level_7",
            "Master SprintING": "https://w3id.org/kim/educationalLevel/level_7",
            "Master Wahlpflichtveranstaltungen": "https://w3id.org/kim/educationalLevel/level_7",
            "Master Wahlveranstaltungen": "https://w3id.org/kim/educationalLevel/level_7",
            "Master": "https://w3id.org/kim/educationalLevel/level_7",
            "Masterlabor": "https://w3id.org/kim/educationalLevel/level_7",
            "Mastermodule: siehe aktuellen Modulkatalog": "https://w3id.org/kim/educationalLevel/level_7",
            "Umweltingenieurwesen, M. Sc. (PO´19)": "https://w3id.org/kim/educationalLevel/level_7",
            "Water Resources and Environmental Management, M. Sc.": "https://w3id.org/kim/educationalLevel/level_7",
        }, None)
